<template>
  <q-page padding>
    <div v-for="(person, index) in persons" :key="index" cols="12" md="4">
      <Person style="margin: 82px" :data="person" menu="VisitsPage" />
    </div>
  </q-page>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { api } from '../boot/axios';
import { useUserStore } from '../stores/user';
import Person from '../components/PersonComponent.vue';

// Define the UserProfile interface
interface UserProfile {
  nick: string;
  image: string;
  age: number;
  city: string;
  loggedIn: boolean;
  lazyImage: string;
}

// Get the user data from the store
const socketStore = useUserStore();
const { user } = socketStore;

// Define the persons array as a ref to make it reactive
const persons = ref<UserProfile[]>([]);

// Fetch the visited users and populate the persons array
api.post('/user/visited', { uuid: user.uuid }).then(({ data }) => {
  persons.value = data.map((person: { name?: string; photos?: string }) => {
    if (!person.photos) return;
    const image = JSON.parse(person.photos).profile;
    const city = person.name;
    delete person['photos'];
    delete person['name'];
    return { ...person, image, city };
  });
});
</script>
